<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.12.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>kmDebug: X:/kmDebug.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">kmDebug
   </div>
   <div id="projectbrief">kmDebug library for AVR</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.12.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search',true);
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('km_debug_8h.html',''); initResizable(true); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="summary">
<a href="#enum-members">Enumerations</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle"><div class="title">X:/kmDebug.h File Reference</div></div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;stdbool.h&gt;</code><br />
<code>#include &quot;../kmCommon/kmCommon.h&quot;</code><br />
</div>
<p><a href="km_debug_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
Enumerations</h2></td></tr>
<tr class="memitem:aa75c08c034edbf8e7d2ab7f4368ba1f3" id="r_aa75c08c034edbf8e7d2ab7f4368ba1f3"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#aa75c08c034edbf8e7d2ab7f4368ba1f3">kmDebugPin</a> { <a class="el" href="#aa75c08c034edbf8e7d2ab7f4368ba1f3a68e15f535d372cae08798ca2f13d7796">DB_PIN_0</a>
 }</td></tr>
<tr class="memdesc:aa75c08c034edbf8e7d2ab7f4368ba1f3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Definition of the kmDebug internal pin number, allows to remap the pins without changing the rest of the code. See <a class="el" href="km_debug_default_config_8h.html" title="Default configuration options that can be overridden in main config file kmDebugDefaultConfig....">kmDebugDefaultConfig.h</a> for details.  <a href="#aa75c08c034edbf8e7d2ab7f4368ba1f3">More...</a><br /></td></tr>
<tr class="separator:aa75c08c034edbf8e7d2ab7f4368ba1f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a2e3f24e3758b6264b61cf4eff527a87f" id="r_a2e3f24e3758b6264b61cf4eff527a87f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a2e3f24e3758b6264b61cf4eff527a87f">dbPullUpAllPorts</a> (void)</td></tr>
<tr class="separator:a2e3f24e3758b6264b61cf4eff527a87f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2d9ae3859d0da45b5a0218aab0387df2" id="r_a2d9ae3859d0da45b5a0218aab0387df2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a2d9ae3859d0da45b5a0218aab0387df2">dbInit</a> (void)</td></tr>
<tr class="separator:a2d9ae3859d0da45b5a0218aab0387df2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a67f16e1067dd9d5aade7458fb706f504" id="r_a67f16e1067dd9d5aade7458fb706f504"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a67f16e1067dd9d5aade7458fb706f504">dbToggle</a> (const <a class="el" href="#aa75c08c034edbf8e7d2ab7f4368ba1f3">kmDebugPin</a> pin)</td></tr>
<tr class="separator:a67f16e1067dd9d5aade7458fb706f504"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa82a2a7cbbce8a6772d96677ef041211" id="r_aa82a2a7cbbce8a6772d96677ef041211"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#aa82a2a7cbbce8a6772d96677ef041211">dbOn</a> (const <a class="el" href="#aa75c08c034edbf8e7d2ab7f4368ba1f3">kmDebugPin</a> pin)</td></tr>
<tr class="separator:aa82a2a7cbbce8a6772d96677ef041211"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a03904c051c3250069b3f565a9c6aee16" id="r_a03904c051c3250069b3f565a9c6aee16"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a03904c051c3250069b3f565a9c6aee16">dbOff</a> (const <a class="el" href="#aa75c08c034edbf8e7d2ab7f4368ba1f3">kmDebugPin</a> pin)</td></tr>
<tr class="separator:a03904c051c3250069b3f565a9c6aee16"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a286c03ef5a95c11c642072f97f5bfa94" id="r_a286c03ef5a95c11c642072f97f5bfa94"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a286c03ef5a95c11c642072f97f5bfa94">dbSet</a> (const <a class="el" href="#aa75c08c034edbf8e7d2ab7f4368ba1f3">kmDebugPin</a> pin, const bool state)</td></tr>
<tr class="separator:a286c03ef5a95c11c642072f97f5bfa94"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Enumeration Type Documentation</h2>
<a id="aa75c08c034edbf8e7d2ab7f4368ba1f3" name="aa75c08c034edbf8e7d2ab7f4368ba1f3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa75c08c034edbf8e7d2ab7f4368ba1f3">&#9670;&#160;</a></span>kmDebugPin</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="#aa75c08c034edbf8e7d2ab7f4368ba1f3">kmDebugPin</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition of the kmDebug internal pin number, allows to remap the pins without changing the rest of the code. See <a class="el" href="km_debug_default_config_8h.html" title="Default configuration options that can be overridden in main config file kmDebugDefaultConfig....">kmDebugDefaultConfig.h</a> for details. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="aa75c08c034edbf8e7d2ab7f4368ba1f3a68e15f535d372cae08798ca2f13d7796" name="aa75c08c034edbf8e7d2ab7f4368ba1f3a68e15f535d372cae08798ca2f13d7796"></a>DB_PIN_0&#160;</td><td class="fielddoc"><p>Debug pin 0. </p>
</td></tr>
</table>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="a2d9ae3859d0da45b5a0218aab0387df2" name="a2d9ae3859d0da45b5a0218aab0387df2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2d9ae3859d0da45b5a0218aab0387df2">&#9670;&#160;</a></span>dbInit()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void dbInit </td>
          <td>(</td>
          <td class="paramtype">void</td>          <td class="paramname"><span class="paramname"><em></em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Initializes the debug pins with HIGH state. Following definitions to be set in config.h file <br  />
#define <b>KM_DEBUG_DDR</b> data direction register for debug pin (e.g DDRC) <br  />
#define <b>KM_DEBUG_PORT</b> debug pin port (e.g PORTC) <br  />
#define <b>KM_DEBUG_PIN_X</b> debug pin (e.g PC1) <br  />
#define <b>KM_DEBUG_INVERT_LOGIC</b> if defined, then dbOn sets the pin to LOW, and dbOff to HIGH ) <br  />
#define <b>KM_DEBUG_DISABLE</b> - to disable debug feature completely <br  />
</p>

</div>
</div>
<a id="a03904c051c3250069b3f565a9c6aee16" name="a03904c051c3250069b3f565a9c6aee16"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a03904c051c3250069b3f565a9c6aee16">&#9670;&#160;</a></span>dbOff()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void dbOff </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="#aa75c08c034edbf8e7d2ab7f4368ba1f3">kmDebugPin</a></td>          <td class="paramname"><span class="paramname"><em>pin</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Issues debug by switching off the debug pin of specific number. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pin</td><td>Pin number from 0 to 7. Note that only pins that have defined DEBUG_PINX are active. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aa82a2a7cbbce8a6772d96677ef041211" name="aa82a2a7cbbce8a6772d96677ef041211"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa82a2a7cbbce8a6772d96677ef041211">&#9670;&#160;</a></span>dbOn()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void dbOn </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="#aa75c08c034edbf8e7d2ab7f4368ba1f3">kmDebugPin</a></td>          <td class="paramname"><span class="paramname"><em>pin</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Issues debug by switching on the debug pin of specific number. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pin</td><td>Pin number from 0 to 7. Note that only pins that have defined DEBUG_PINX are active. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a2e3f24e3758b6264b61cf4eff527a87f" name="a2e3f24e3758b6264b61cf4eff527a87f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2e3f24e3758b6264b61cf4eff527a87f">&#9670;&#160;</a></span>dbPullUpAllPorts()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void dbPullUpAllPorts </td>
          <td>(</td>
          <td class="paramtype">void</td>          <td class="paramname"><span class="paramname"><em></em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Initializes all ports to pull-up state. <b>NOTE:</b> This method should be issued first in the main routine </p>

</div>
</div>
<a id="a286c03ef5a95c11c642072f97f5bfa94" name="a286c03ef5a95c11c642072f97f5bfa94"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a286c03ef5a95c11c642072f97f5bfa94">&#9670;&#160;</a></span>dbSet()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void dbSet </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="#aa75c08c034edbf8e7d2ab7f4368ba1f3">kmDebugPin</a></td>          <td class="paramname"><span class="paramname"><em>pin</em></span>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const bool</td>          <td class="paramname"><span class="paramname"><em>state</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Issues debug by switching on or off the debug pin of specific number depends on the state parameter </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pin</td><td>Pin number from 0 to 7. Note that only pins that have defined DEBUG_PINX are active. </td></tr>
    <tr><td class="paramname">state</td><td>if true switches the debug pin ON, OFF otherwise </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a67f16e1067dd9d5aade7458fb706f504" name="a67f16e1067dd9d5aade7458fb706f504"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a67f16e1067dd9d5aade7458fb706f504">&#9670;&#160;</a></span>dbToggle()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void dbToggle </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="#aa75c08c034edbf8e7d2ab7f4368ba1f3">kmDebugPin</a></td>          <td class="paramname"><span class="paramname"><em>pin</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Issues next debug by toggling the debug pin of specific number. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pin</td><td>Pin number from 0 to 7. Note that only pins that have defined DEBUG_PINX are active. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="km_debug_8h.html">kmDebug.h</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.12.0 </li>
  </ul>
</div>
</body>
</html>
